const
  max_n = 50;
  e = 0.0001;

var
  tk : array [1..3, 0..max_n+2] of extended;
  ds : array [1..3, 0..max_n+2] of longint;
  heap : array [0..max_n+1] of longint;
  d3 : array [1..max_n+2] of extended;
  tek, xn, yn, zn, max : extended;
  count, mx, d1l, d1r, d2l, d2r, n, i, j, d : longint;

function compare ( x, y : longint ) : boolean;
begin
  if tk[d,x] > tk[d, y] then compare := true
                        else compare := false;
end;

procedure add ( x : longint );
var
  k : longint;
begin
  inc(count);
  k := count;
  while compare(heap[k shr 1], x) do
  begin
    heap[k] := heap[k shr 1];
    k := k shr 1
  end;
  heap[k] := x;
end;

procedure Get ( var x : longint );
var
  i, k : longint;
begin
  x := heap[1];
  k := 1;
  while k shl 1 <= count do
  begin
    i := k shl 1;
    if ( i<count ) and( compare( heap[i], heap[i+1] )) then inc(i);
    heap[k] := heap[i];
    k := i;
  end;
  while compare( heap[k shr 1], heap[count] ) do
  begin
    heap[k] := heap[k shr 1];
    k := k shr 1;
  end;
  heap[k] := heap[count];
  dec(count)
end;

begin
  assign(input,'input.txt');
  reset(input);
  readln(xn, yn, zn);
  readln(n);
  for i:=1 to n do
  begin
    read( tk[1,i] );
    read( tk[2,i] );
    read( tk[3,i] );
    readln;
  end;
  close(input);
  count := 0;
  tk[1, 0] := -1;
  tk[2, 0] := -1;
  tk[3, 0] := -1;
  tk[1, n+1] := 0;
  tk[2, n+1] := 0;
  tk[3, n+1] := 0;
  tk[1, n+2] := xn;
  tk[2, n+2] := yn;
  tk[3, n+2] := zn;
  heap[0] := 0;
  for d := 1 to 3 do
  begin
    for i:=1 to n+2 do
      add(i);
    for i:=1 to n+2 do
      get( ds[d,i] );
  end;
  max := 0;
  for d1l:=1 to n+1 do
    for d1r:=d1l+1 to n+2 do
    for d2l := 1 to n+1 do
      for d2r := d2l+1 to n+2 do
      begin
        tek:= tk[1,ds[1,d1r]]-tk[1,ds[1,d1l]];
        tek := tek*(tk[2,ds[2,d2r]]-tk[2,ds[2,d2l]]);
        d3[1] := 0;
        j := 1; mx := 1;
        for i:=2 to n+2 do
        begin
          d3[i] := tk[3,ds[3,i]] - tk[3,ds[3,j]];
          if (tk[1,ds[1,d1l]]-tk[1,ds[3,i]]<=e)and
             (tk[1,ds[1,d1r]]-tk[1,ds[3,i]]>=e)and
             (tk[2,ds[2,d2l]]-tk[2,ds[3,i]]<=e)and
             (tk[2,ds[2,d2r]]-tk[2,ds[3,i]]>=e) then j := i;
          if d3[mx]<d3[i] then mx := i;
        end;
        if tek*d3[mx] > max then max := tek*d3[mx];
      end;
  assign(output,'output.txt');
  rewrite(output);
  writeln(max:0:2);
  close(output);
end.
